// C Source File
// Created 7/2/2003; 7:49:14 PM

#define USE_TI89              // Compile for TI-89

#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization

#define MIN_AMS 200           // Compile for AMS 1.00 or higher

#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files

// Main Function
char *str[20];



void Drawtitle(const char *s)
{

	short length=strlen (s);
	length=((160-(length*6))/2);
	DrawStr(length,19,s,A_NORMAL);
}
void DrawBox(int x1,int y1,int xsize,int ysize,int style)
{
char styles[8]={A_NORMAL,A_REVERSE,A_XOR,A_THICK1,A_SHADE_V,A_SHADE_H,A_SHADE_NS,A_SHADE_PS}; 

int r;
for (r=x1;r<x1+xsize;r++)
{
DrawLine(r,y1,r,y1+ysize,A_REVERSE);
}
DrawLine(x1,y1,x1+xsize,y1,styles[style]);
DrawLine(x1,y1,x1,y1+ysize,styles[style]);
DrawLine(x1+xsize,y1,x1+xsize,y1+ysize,styles[style]);
DrawLine(x1,y1+ysize,x1+xsize,y1+ysize,styles[style]);
}
void drawstr(int x,int y,int font,int style,const char *strr)
{
	char styles[5]={A_NORMAL,A_REVERSE,A_REPLACE,A_XOR,A_SHADED};
	char fonts[3]= {F_4x6, F_6x8, F_8x10};
	FontSetSys (fonts[font]);
	DrawStr(x,y,strr,styles[style]);
}
void Drawcline(int x1,int y1,int x2,int y2,int style)
{
char styles[8]={A_NORMAL,A_REVERSE,A_XOR,A_THICK1,A_SHADE_V,A_SHADE_H,A_SHADE_NS,A_SHADE_PS}; 
DrawLine(x1,y1,x2,y2,styles[style]);
}
void InputStr(char *buffer, unsigned short maxlen,int x,int y)
{
  SCR_STATE ss;
  short key;
  unsigned short i = 0;
  buffer[0] = 0;
  SaveScrState (&ss);
  ss.CurY=y;
  ss.CurX=x;
  do
    {
      MoveTo (ss.CurX, ss.CurY);
      printf ("%s_  ", buffer);
        // Note that two spaces are required only if the F_4x6 font is used
      key = ngetchx ();
      if (key >= ' ' && key <= '~' && i < maxlen)
        buffer[i++] = key;
      else if (key == KEY_BACKSPACE && i)
        i--;
      buffer[i] = 0;
    } while (key != KEY_ENTER&&key!=KEY_ESC);
    if (key==KEY_ESC)
    for (i=0;i<maxlen;i++)
    buffer[0]=0;
}
void Savevar(char *s)
{
FILE *f = fopen ("x", "wb");
fputc (0, f);
fputs (s, f);
fputc (0, f);
fputc (STR_TAG, f);
fclose (f);


}
void drawdiagbox(const char *title,const char *prompt,const char *text1,const char *text2)
{


	DrawBox(0,16,158,76,3);
	Drawcline(1,27,158,27,3);
	Drawtitle(title);
	drawstr(3,30,1,0,prompt);
	DrawBox(3,40,140,10,0);
	InputStr(str,2,4,42);
	drawstr(3,50,0,0,text1);
	drawstr(3,60,0,0,text2);
}

void _main(void)
{
	ESI argptr;
  int argtype;
   InitArgPtr (argptr);
  int r=0;
  char *str2[4]={0,0,0,0};
   
  while ((argtype = GetArgType (argptr)) != END_TAG)
    {
       if (argtype == STR_TAG)
     		str2[r]=GetStrnArg (argptr);
 				r++;
    }


drawdiagbox(str2[0],str2[1],str2[2],str2[3]);

Savevar(str);
}
